using System;
using System.Runtime.Serialization;
using System.Xml.Serialization;
using System.Xml;
using System.Text;
//using System.Windows.Forms;
namespace WmpNowRS
{
	/// <summary>
	///    
	/// Structure for storage of the information
	/// </summary>
	[Serializable(), XmlRoot("media")]
	public class MediaInfo {
		[XmlElement()]
		public string Name;
		[XmlElement()]
		public string MediaType;
		[XmlElement()]
		public string Artist;
		[XmlElement()]
		public string Album;
		[XmlElement()]
		public string TrackNumber;
		[XmlElement()]
		public string Genre;
		[XmlElement()]
		public string Duration;
		[XmlElement()]
		public string Bitrate;
		[XmlElement()]
		public string FileType;
		[XmlElement()]
		public string FileSize;
		[XmlElement()]
		public string SourceUrl;
		[XmlAttribute()]
		public string PlayerVersion;
		[XmlAttribute()]
		public string PlayerStatus;

		public void assign(MediaInfo mf){
			this.Album=mf.Album;
			this.Artist=mf.Artist;
			this.Bitrate=mf.Bitrate;
			this.Duration=mf.Duration;
			this.FileSize=mf.FileSize;
			this.FileType=mf.FileType;
			this.Genre=mf.Genre;
			this.MediaType=mf.MediaType;
			this.Name=mf.Name;
			this.PlayerStatus=mf.PlayerStatus;
			this.PlayerVersion=mf.PlayerVersion;
			this.SourceUrl=mf.SourceUrl;
			this.TrackNumber=mf.TrackNumber;
		}
//		public bool SaveTo(string FileName){
//			XmlSerializer serializer;
//			Type t = this.GetType();
//			XmlTextWriter writer=null;
//			try{
//				serializer = new XmlSerializer(t);
//				writer = new XmlTextWriter(FileName, Encoding.UTF8);
//				writer.Formatting = Formatting.Indented;
//				serializer.Serialize(writer, this);
//				return true;
//			}catch(Exception err){
//				MessageBox.Show(err.Message,"Error while saving "+this.GetType().Name);
//				return false;
//			}finally{
//				if(writer!=null) writer.Close();
//			}
//		}
		public bool RestoreFrom(string FileName){
			Type t=this.GetType();
			XmlSerializer serializer = new XmlSerializer(t);
			XmlTextReader reader=null;
			try{
				reader = new XmlTextReader(FileName);
				MediaInfo res=(MediaInfo)serializer.Deserialize(reader);
				this.assign(res);
				return true;
			}catch{
				return false;
			}finally{
				if(reader!=null) reader.Close();
			}
		}
	}
}
