using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;
using WmpNowRS;
namespace WmpNowWC
{
	/// <summary>
	/// Summary description for WebCustomControl1.
	/// </summary>
	[DefaultProperty("Text"),
	ToolboxData("<{0}:WmpNowPlayingControl runat=server></{0}:WmpNowPlayingControl>")]
	public class WmpNowPlayingControl : System.Web.UI.WebControls.Label {
		private string text;
		private string format;
		private string path;
		MediaInfo info;

		[Bindable(true),
		Category("Appearance"),
		DefaultValue("")]
		public override string Text {
			get {
				return text;
			}

			set {
				text = value;
			}
		}

		/// <summary>
		/// Render this control to the output parameter specified.
		/// </summary>
		/// <param name="output"> The HTML writer to write out to </param>
		protected override void Render(HtmlTextWriter output) {
			info=new MediaInfo();
			try{
				info.RestoreFrom(path);
				text=string.Format(format,
					info.Name/*0*/,info.Album/*1*/,info.Artist/*2*/,info.Genre/*3*/,
					info.FileType/*4*/,info.Bitrate/*5*/,info.Duration/*6*/,
					info.PlayerVersion/*7*/);
			}catch(Exception er){
				text=er.Message;
			}
			base.Render(output);
			//output.Write(Text);
		}

		/// <summary>
		/// Format string [like in String.Format()]:<br/>
		/// {0} - Name of media,<br/>
		/// {1} - Album, {2} - Artist, {3} - Genre,<br/>
		/// {4} - Type(wma,mp3 etc), {5} - Bitrate,<br/>
		/// {6} - Duration, {7} - PlayerVersion
		/// </summary>
		[DefaultValue("[WMP {7}]: {0} [by {2}]")]
		public string Format {
			get {return format;}
			set {format=value;}
		}

		/// <summary>
		/// Path to info file
		/// </summary>
		[DefaultValue(@"C:\Program Files\DkmS\Wmp Now\Msg\audio.wmpnow"),
		Description("Path to info file")]
		public string Path {
			get {return path;}
			set {path=value;}
		}
	}
}
